#include <bits/stdc++.h>
using namespace std;
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, k; string s; cin >> n >> k >> s;
    s = '^' + s; int raz = 0;
    vector<int> occ(130, 0);
    for(int i = 1; i <= n; ++i){
        occ[(int)s[i]]++;
        int mn = INT_MAX;
        for(int i = 'a'; i < k + 'a'; ++i)
            mn = min(mn, occ[i]);
        if(mn == 0)
            cout << 1 << ' ';
        else
            cout << mn + 1 << ' ';
    }
    return 0;
}